 function [Q,T,res] = subsit1(A, Q, nit, p) 
%% function [Q,T,res] = subsit1(A, Q, nit, p) 
%%
%% does "nit" steps of subspace iteration 
%% (with a Schur projection every 10 steps)
%% on return
%% Q   = orth. basis of invariant subspace
%% T   = Q'*A*Q = projection of A on Q.
%%------------------------------------------------ 
%% Q = qr(Q,0); AQ = A*Q;
 k = 0;
 %%fi = fopen('iters','w');
 fi =1;
 for i=1:nit
   AQ = A*Q;
   [Q,R] = qr(AQ,0); 
   if (mod(i,10) == 0) 
     [U,T] = eig(Q'*AQ); 
     Q = Q*U;
     AQ  = A*Q;  
     [~, ind] = sort(abs(diag(T)),'descend');
     ind = ind(1:p);
     R   = AQ(:,ind) - Q(:,ind)*T(ind,ind); 
     t =  norm(R,1);
     k = k+1;     res(k) = t; 
     fprintf(fi,' it %3d ; res: %10.4e   %10.4e \n',i,t);
     fprintf(fi,'          lam: %12.10f %12.10f \n',T(1,1), T(2,2)) ;
   end 
 end


