 function [V] = KPCA (X,K,d)
%  function [V] = KPCA (X,K,d)
% Inputs:
% X = data as m x n matrix (D = dimensionality, n = #points)
% K = number of neighbors 
% d = embedding dimensionality
% Outputs:
% V = embedded data dimension d x n 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[m,n] = size(X);
X=double(X);    %% just in case
GR = X'*X;
norms2 = sum(X.^2);     %% a row vector
%% 

dist2 = ones(n,1)*norms2 + norms2'*ones(1,n) - 2*GR;

dist2 = exp(-0.001*dist2); 

M = dist2; 
%%--------------------EMBEDDING
options.disp = 0; options.isreal = 1; options.issym = 1; 
%%[V,eigenvals] = eigs(M,d,'LM',options);
[V,eigenvals] = eig(full(M)); 
[eigval,index] = sort(diag(eigenvals),'descend');
V = V(:,index);
V = V(:,1:d)'; 
