 function [V,H] = arnoldi (A,v,m) 
%  [V,H] = arnoldi (A,v,m) performs m steps of the
%  arnoldi process. 
%  V is n x (m+1)  contains v1 ... v_{m+1} 
%  H is (m+1) x m 
%%-----------------------------------------------
ro = norm(v,2);
V(:,1) = v/ro; 
for i=1:m 
    i1 = i + 1  ;
    V(:,i1) = A*V(:,i)  ;
%------     modified GS  ;
    for j=1:i
        t = V(:,j)'*V(:,i1)  ;
        H(j,i) = t  ;
	V(:,i1) = V(:,i1) - t*V(:,j)  ;
    end
    t = norm(V(:,i1),2)  ;
    H(i1,i) = t  ;
    if (t  ~= 0.0)  
        t = 1.0 / t  ;
	V(:,i1) = V(:,i1)*t  ;
    end
end  
